function A=wholeMatrix(N)
    a=zeros(N^3,19);b=a;c=a;h=2*pi/N;
 
    d=inline('floor((M+1-l)/M)*M+l-1');u=inline('l+1-floor(l/M)*M');
    k=inline('rem(ss-1,M)+1');j=inline('rem(floor((ss-1)/M),M)+1');i=inline('floor((ss-1)/M^2)+1');
    ss=(1:N^3)';r=ones(N^3,1);xlab=i(N,ss);ylab=j(N,ss);zlab=k(N,ss);
    
    cosx=cos((xlab-1)*h);xy=-0.5*sin((xlab-1)*h+(ylab-1)*h);
    yz=-0.5*(1+cos((xlab-1)*h));xz=-cos((ylab-1)*h)/3;
    
    a(ss,:)=ss*ones(1,19);
    c(ss,:)=[-(16+5*cosx).*r/3    ...,
            r     r     ...,
            (1+cosx*0.5).*r   (1+cosx*0.5).*r ...,
            (2+cosx)/3.*r     (2+cosx)/3.*r ...,
            xy.*r/4   xy.*r/4   -xy.*r/4   -xy.*r/4 ...,
            yz.*r/4   yz.*r/4   -yz.*r/4   -yz.*r/4 ...,
            xz.*r/4   xz.*r/4   -xz.*r/4   -xz.*r/4]/h^2;
    b(ss,:)=[xlab*N*N+ylab*N+zlab ...,
        d(N,xlab)*N*N+ylab*N+zlab u(N,xlab)*N*N+ylab*N+zlab ...,
        xlab*N*N+d(N,ylab)*N+zlab xlab*N*N+u(N,ylab)*N+zlab ...,
        xlab*N*N+ylab*N+d(N,zlab) xlab*N*N+ylab*N+u(N,zlab) ...,
        d(N,xlab)*N*N+d(N,ylab)*N+zlab u(N,xlab)*N*N+u(N,ylab)*N+zlab ...,
        u(N,xlab)*N*N+d(N,ylab)*N+zlab d(N,xlab)*N*N+u(N,ylab)*N+zlab ...,
        xlab*N*N+d(N,ylab)*N+d(N,zlab) xlab*N*N+u(N,ylab)*N+u(N,zlab) ...,
        xlab*N*N+d(N,ylab)*N+u(N,zlab) xlab*N*N+u(N,ylab)*N+d(N,zlab) ...,
        d(N,xlab)*N*N+ylab*N+d(N,zlab) u(N,xlab)*N*N+ylab*N+u(N,zlab) ...,
        d(N,xlab)*N*N+ylab*N+u(N,zlab) u(N,xlab)*N*N+ylab*N+d(N,zlab)]-N^2-N;
    A=sparse(a,b,c,N^3,N^3);