%% final numerical test

NXmax=100;NEXmax=45;
Nx=35;Nex=20;
M=Nx+1;N=Nex+1;
hx=NXmax/Nx;hex=NEXmax/Nex;
p=zeros(M*M*N,1);

for i=1:M
    for j=1:M
        for k=1:N
            x=(i-1)*hx;y=(j-1)*hx;z=(k-1)*hex;
            p((i-1)*M*N+(j-1)*N+k)=1/100*exp(-((x-30)^2+(y-40)^2+(z-20)^2)/30);
        end;
    end;
end;
p=p/sum(p);

baseZ=1:1:N;
baseXY=1:N:(N*M*M);

pz=zeros(N,1);
for k=1:N
    for i=1:M
        for j=1:M
            pz(k)=pz(k)+p((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;
subplot(2,2,1),plot((0:Nex)*hex,pz);
        

pxy=zeros(M,M);
for i=1:M
    
    for j=1:M
        for k=1:N
            pxy(i,j)=pxy(i,j)+p((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;
subplot(2,2,3),surf(pxy,'EdgeColor','none');
shading interp;
axis([0 M 0 M]);

dt=1;totprb=zeros(1,51);totprb(1)=sum(p);
for kkk=1:50
    disp(kkk);
    
    disp(sum(p));
    disp(min(p));
    % XY plane
    for k=1:N
        z=(k-1)*hex;B=getXYnew(NXmax,Nx,z,z);
        if max(abs(p(baseXY+(k-1))))>1e-10
            p(baseXY+(k-1))=expv(dt/2,B,p(baseXY+(k-1)));
        end;
    end;
    
    % Z plane
    for i=1:M
        x=(i-1)*hx;A=getEX(NEXmax,Nex,x);
        for j=1:M
            if max(abs(p(baseZ+(i-1)*M*N+(j-1)*N)))>1e-10
            p(baseZ+(i-1)*M*N+(j-1)*N)=expv(dt,A,p(baseZ+(i-1)*M*N+(j-1)*N));
            end;
        end;
    end;
    
    % XY plane
    for k=1:N
        z=(k-1)*hex;B=getXYnew(NXmax,Nx,z,z);
        if max(abs(p(baseXY+(k-1))))>1e-10
            p(baseXY+(k-1))=expv(dt/2,B,p(baseXY+(k-1)));
        end;
    end;
    totprb(kkk+1)=sum(p);
end;

pz=zeros(N,1);
for k=1:N
    for i=1:M
        for j=1:M
            pz(k)=p((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;
subplot(2,2,2),plot((0:Nex)*16,pz);
pxy=zeros(M,M);
for i=1:M
    for j=1:M
        for k=1:N
            pxy(i,j)=pxy(i,j)+p((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;
subplot(2,2,4),surf(pxy,'EdgeColor','none');
shading interp;
axis([0 M 0 M]);


