%% test if the probability matrix is right
% A<->B
%% 2D matrix test
% N=30;p=zeros((N+1)^2,1);p(N*(N+1)+1)=1;
% Pab=GetMatrix(N,1,5);
% tend=10;
% Eab=expm(Pab*tend);
% pend=Eab*p;
% avera=zeros(N+1,1);averb=zeros(N+1,1);
% disp(sum(pend));
% for i=1:N+1
%     for j=1:N+1
%         avera(i)=avera(i)+pend((i-1)*(N+1)+j);
%         averb(j)=averb(j)+pend((i-1)*(N+1)+j);
%     end;
% end;
% disp({(0:N)*avera,(0:N)*averb});

%% 3D matrix test
N=35;M=N+1;p=zeros(M^3,1);p((M-1)*M^2+1)=1;
tend=10;
Pwhole=whole3D(N,1,2,1,2);
pend=expv(tend,Pwhole,p);
disp(sum(p));
pa=zeros(M,1);pb=pa;pc=pa;
for i=1:N+1
    for j=1:N+1
        for k=1:N+1
            pa(i)=pa(i)+pend((i-1)*M^2+(j-1)*M+k);
            pb(j)=pb(j)+pend((i-1)*M^2+(j-1)*M+k);
            pc(k)=pc(k)+pend((i-1)*M^2+(j-1)*M+k);
        end;
    end;
end;
disp({(0:N)*pa,(0:N)*pb,(0:N)*pc});