%% Some preparation
N=64;h=2*pi/N;
disp('N=');disp(N);

base1=1:N^2;base2=zeros(1,N^2);base3=zeros(1,N^2);
for i=1:N
    base2((1:N)+(i-1)*N)=(1:N)+(i-1)*N^2;
    base3((1:N)+(i-1)*N)=(1:N:(N*N-N+1))+(i-1)*N^2;
end;
Axy=XYNonMatrix(N);Ayz=YZNonMatrix(N);Awhole=wholeMatrix(N);


sol1=rand(N^3,1);sol2=sol1;ans1=zeros(N^3,1);
    for i=1:N
        ans1(base3+(i-1))=ans1(base3+(i-1))+Axy*sol1(base3+(i-1));
    end;
    % yz plane
    for i=1:N
        x=(i-1)*h;
        ans1(base1+(i-1)*N^2)=ans1(base1+(i-1)*N^2)+(1+cos(x))*Ayz*sol1(base1+(i-1)*N^2);
    end;
    % xz plane-dt
    for i=1:N
        y=(i-1)*h;Axz=XZNonMatrix(N,y);
        ans1(base2+(i-1)*N)=ans1(base2+(i-1)*N)+Axz*sol1(base2+(i-1)*N);
    end;
ans2=Awhole*sol2;
disp('the test result for all matrices are');
disp({'the error is:   ' ,  max(abs(ans1-ans2))});  

%% Conclusion:
% All matrices are set to be right.