function p=IIF_Result(p0,dt,tend,Nx,Nex)
    NXmax=100;NEXmax=60;
    M=Nx+1;N=Nex+1;
    hx=NXmax/Nx;hex=NEXmax/Nex;
    p=p0;
    baseZ=1:1:N;baseXY=1:N:(N*M*M);

    for kkk=1:round(tend/dt)
        % XY plane
        for k=1:N
            z=(k-1)*hex;B=getXYnew(NXmax,Nx,z,z);
            if max(abs(p(baseXY+(k-1))))>1e-10
                p(baseXY+(k-1))=expv(dt/2,B,p(baseXY+(k-1)));
            end;
        end;
    
        % Z plane
        for i=1:M
            x=(i-1)*hx;A=getEX(NEXmax,Nex,x);
            for j=1:M
                if max(abs(p(baseZ+(i-1)*M*N+(j-1)*N)))>1e-10
                p(baseZ+(i-1)*M*N+(j-1)*N)=expv(dt,A,p(baseZ+(i-1)*M*N+(j-1)*N));
                end;
            end;
        end;
    
        % XY plane
        for k=1:N
            z=(k-1)*hex;B=getXYnew(NXmax,Nx,z,z);
            if max(abs(p(baseXY+(k-1))))>1e-10
                p(baseXY+(k-1))=expv(dt/2,B,p(baseXY+(k-1)));
            end;
        end;
        disp(kkk);
        disp(sum(p));
        disp(min(p));
 
    end;
