%% plot initial data
pini=zeros(M*M*N,1);
for i=1:M
    for j=1:M
        for k=1:N
            x=(i-1)*hx;y=(j-1)*hx;z=(k-1)*hex;
            pini((i-1)*M*N+(j-1)*N+k)=1/100*exp(-((x-30)^2+(y-40)^2+(z-20)^2)/30);
        end;
    end;
end;
pini=pini/sum(pini);
pxy1=zeros(M,M);
for i=1:M
    
    for j=1:M
        for k=1:N
            pxy1(i,j)=pxy1(i,j)+pini((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;
XX=linspace(0,NXmax,M);
subplot(2,2,1),surf(XX,XX,pxy1,'EdgeColor','none');
shading interp;

%% plot final data
subplot(2,2,2),surf(XX,XX,pxy.*(pxy>0),'EdgeColor','none');
shading interp;

%% plot contour plot
subplot(2,2,3),contour(XX,XX,pxy1,6),hold on;
contour(XX,XX,pxy,6);
[t solx]=ode45(@reactode,[0 50],[30 40 20]);
plot(solx(:,2),solx(:,1),'r -.');
hold off;


%% plot the total probability
pz=zeros(N,1);
for k=1:N
    for i=1:M
        for j=1:M
            pz(k)=pz(k)+p((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;
subplot(2,2,4),plot(0:50,totprb),axis([0 50 0.9 1.1]);
        