%% Test Two method time
NXmax=100;NEXmax=60;
Nx=40;Nex=24;
M=Nx+1;N=Nex+1;hx=NXmax/Nx;hex=NEXmax/Nex;
p=zeros(M*M*N,1);
for i=1:M
    for j=1:M
        for k=1:N
            x=(i-1)*hx;y=(j-1)*hx;z=(k-1)*hex;
            p((i-1)*M*N+(j-1)*N+k)=1/100*exp(-((x-30)^2+(y-40)^2+(z-25)^2)/30);
        end;
    end;
end;

dt1=0.03;dt2=3;

tic;
p1=RK_Result(p,dt1,30,Nx,Nex);
disp('time for RK2');
toc;
disp('the error for RK2');
disp(get_Error(p1,Nx,Nex,pexa,200,120));

tic;
p2=IIF_Result(p,dt2,30,Nx,Nex);
disp('time for IIF');
toc;
disp('the error for IIF');
disp(get_Error(p2,Nx,Nex,pexa,200,120));
