%% plot A-B final distribution
pini=zeros(M1*M1*M2*M2,1);
for i1=1:M1
    for i2=1:M1
        for i3=1:M2
            for i4=1:M2
                numa=(i1-1)*h1;numb=(i2-1)*h1;ea=(i3-1)*h2;eb=(i4-1)*h2;
                pini((i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2+i4)=exp(-((numa-30)^2+(numb-40)^2+(ea-15)^2+(eb-12)^2)/30);
            end;
        end;
    end;
end;
pini=pini/sum(pini);
piab=zeros(M1,M1);pie=zeros(M2,M2);
for i1=1:M1
    for i2=1:M1
        for i3=1:M2
            for i4=1:M2
                piab(i1,i2)=piab(i1,i2)+pini((i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2+i4);
                pie(i3,i4)=pie(i3,i4)+pini((i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2+i4);
            end;
        end;
    end;
end;

XX=linspace(0,NAmax,NA+1);
subplot(2,2,1);
surf(XX,XX,pab,'EdgeColor','none');shading interp;
axis([0 80 0 80 0 0.01]),
xlabel('[B]','FontSize',15),
ylabel('[A]','FontSize',15),title('A','FontSize',15),zlabel('probability density   ','FontSize',15);

%% plot contour 

pab=zeros(M1,M1);pe=zeros(M2,M2);
    for i1=1:M1
        for i2=1:M1
            for i3=1:M2
                for i4=1:M2
                pab(i1,i2)=pab(i1,i2)+p((i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2+i4);
                pe(i3,i4)=pe(i3,i4)+p((i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2+i4);
                end;
            end;
        end;
    end;

subplot(2,2,2);
contour(XX,XX,piab,7),hold on;contour(XX,XX,pab,7);
[ttt xxx]=ode45(@reactode,[0 40],[30,40,15,12]);
plot(xxx(:,2),xxx(:,1),'r -.');hold off;
xlabel('[B]','FontSize',15),
ylabel('[A]','FontSize',15),title('B','FontSize',15)
%% plot EA-EA distribution
YY=linspace(0,NEAmax,NEA+1);subplot(2,2,3);
surf(YY,YY,pe,'EdgeColor','none');shading interp;
axis([0 NEAmax 0 NEAmax 0 0.05]);
xlabel('[EB]','FontSize',15),
ylabel('[EA]','FontSize',15),title('C','FontSize',15),zlabel('probability density   ','FontSize',15);

%% plot EA-EA contour
subplot(2,2,4),contour(YY,YY,pie,5),hold on;contour(YY,YY,pe,5);
plot(xxx(:,4),xxx(:,3));hold off;
xlabel('[EB]','FontSize',15),
ylabel('[EA]','FontSize',15),title('D','FontSize',15)
